/////////////////////
#include <acknex.h>
#include <default.c>
/////////////////////
/*
Title:	2D-breakout (not a finished game)
Author:	mercuryus/u.seiffert/gameus!de
Date:		04.09
web:		www.gameus.de
Release:	3dgs winter contest 2008

description:
============
lite-c (v7.70)
A not fully 2D breakout "game".
The graphic is completely made with panels, no level loeded at all.

The concept is to create a large number of panels (object) with different functions (objtype).
There are walls (objtype=1), balls (objtype=2), bricks (objtype=3) a catcher (objtype=5)
A inactive panel is indicated by objtype=0 (e.g. a lost ball or a removed brick)

This project was created to show tha basic methods of 2D-games made with panels including a collision detection calculation
Collision is made for rounded balls

*/

PANEL*	eCatcher = NULL;

BMAP*		bmp_ball;				// the ball 
BMAP*		bmp_wall;				// the wall

PANEL* 	object[50];				// the objects (panel)
var		objtype[50];			// object type (0=off, 1=wall, 2=ball, 3=brick, 4=simple catcher, 5=rounded catcher)
var		gv_max_objects;		// number of objects
var		gv_score		= 0;		// tha score

FONT*		fnt_score	= "Arial#28b";

TEXT* txt_info = {
	layer=2;
	alpha=100;
	pos_x=20;
	font="Times#30b";
	red=0;green=0;blue=0;	
	string = "2D-screensaver by mercuryus / 2009 for the winter contest 2008";
	flags=VISIBLE | TRANSLUCENT;
}

PANEL* pan_score = {
	layer=2;	
	pos_y=3;	
	red=0;green=0;blue=0;	
	digits=0,0,"your score: %5.0f",fnt_score, 1, gv_score;
	flags=VISIBLE | CENTER_X;
}

function flash_screen(){
int i, j, h, g;	

	j=random(255);
	h=random(255);
	g=random(255);
	i=100;
	while(i>0){
		i=maxv(i-15*time_step,0);
		vec_set(screen_color,vector(g*i/100,j*i/100,h*i/100));
		wait(1);
	}
	vec_set(screen_color,nullvector);
}

//========================================================================================================
function brick_fall(var p_id){
var lv_speed=0;
var lv_rotdir=1;

	if(random(1)>.5){lv_rotdir*=-1;} // random rot. dir
	objtype[p_id]=0;		// disable
	while(object[p_id].pos_y<screen_size.y*1.1){
		lv_speed=minv(lv_speed+time_step,30);
		object[p_id].pos_y+=time_step*lv_speed;
		object[p_id].angle=(object[p_id].angle+lv_rotdir*time_step*(3+random(2)))%360;
		wait(1);
	}	
	pan_remove(object[p_id]);	// remove
}
//========================================================================================================
// move the ball (bouncing from other active objects)
function move_ball(var p_id, p_x, p_y){
var lv_speedX, lv_speedY;
var lv_maxspdX, lv_maxspdY;
var lv_id;
int i;
var lv_help;

	// store id
	lv_id=p_id;

	// local speed management
	lv_speedX=p_x;
	lv_maxspdX=p_x;
	lv_speedY=p_y;
	lv_maxspdY=p_y;
	
	while(1){
		
		// calculate the new position
		object[lv_id].pos_x+=lv_speedX*time_step;
		object[lv_id].pos_y+=lv_speedY*time_step;
		
		// bounce with any object?
		for(i=0;i<=gv_max_objects;i++){
			
			// if object is still on
			if(objtype[i]>0){
				
				// collision with an other object (X)?
				if(i!=lv_id){
					// X
					if(						
						(lv_speedX>0 && object[lv_id].pos_x+bmap_width(object[lv_id].bmap)*object[lv_id].scale_x>object[i].pos_x && object[lv_id].pos_x<object[i].pos_x+bmap_width(object[i].bmap)*object[i].scale_x
						&& object[lv_id].pos_y+object[lv_id].center_y>object[i].pos_y && object[lv_id].pos_y+object[lv_id].center_y<object[i].pos_y+bmap_height(object[i].bmap)*object[i].scale_y)
						
						||
						
						(lv_speedX<0 && object[lv_id].pos_x<object[i].pos_x+bmap_width(object[i].bmap)*object[i].scale_x && object[lv_id].pos_x>object[i].pos_x
						&& object[lv_id].pos_y+object[lv_id].center_y>object[i].pos_y && object[lv_id].pos_y+object[lv_id].center_y<object[i].pos_y+bmap_height(object[i].bmap)*object[i].scale_y)
						
					){						
						// ball or wall
						if(objtype[i]==3){
							brick_fall(i);
							gv_score+=100;
							flash_screen();
						}
						
						lv_speedX*=-1;	// turn X
						object[lv_id].pos_x+=lv_speedX*time_step*2;
					} 
					// Y	
					if(
						
						(lv_speedY<0 && object[lv_id].pos_y<object[i].pos_y+bmap_height(object[i].bmap)*object[i].scale_y && object[lv_id].pos_y>object[i].pos_y
						&& object[lv_id].pos_x+object[lv_id].center_x>object[i].pos_x && object[lv_id].pos_x+object[lv_id].center_x<object[i].pos_x+bmap_width(object[i].bmap)*object[i].scale_x)
						
						||
						
						(lv_speedY>0 && object[lv_id].pos_y+bmap_height(object[lv_id].bmap)*object[lv_id].scale_y>object[i].pos_y && object[lv_id].pos_y<object[i].pos_y+bmap_height(object[i].bmap)*object[i].scale_y
						&& object[lv_id].pos_x+object[lv_id].center_x>object[i].pos_x && object[lv_id].pos_x+object[lv_id].center_x<object[i].pos_x+bmap_width(object[i].bmap)*object[i].scale_x)
						
					){
						// brick, wall, ball, catcher
						switch(objtype[i]){
							case 1:
							case 2:	// wall & ball
										lv_speedY*=-1;	// turn Y
										object[lv_id].pos_y+=lv_speedY*time_step*2;			
										break;
							case 3:	// brick
										brick_fall(i);
										gv_score+=100;
										flash_screen();
										lv_speedY*=-1;	// turn Y
										object[lv_id].pos_y+=lv_speedY*time_step*2;
										break;
							case 4:	// simple catcher
										lv_speedY*=-1;	// turn Y
										object[lv_id].pos_y+=lv_speedY*time_step*2;			
										break;
							case 5:	// special catcher (rounded)
										lv_help=clamp(((object[lv_id].pos_x+bmap_width(object[lv_id].bmap)*object[lv_id].scale_x*0.5)-(eCatcher.pos_x+bmap_width(eCatcher.bmap)*eCatcher.scale_x*0.5))/(bmap_width(eCatcher.bmap)*eCatcher.scale_x*0.5), -.9, .9);
										lv_speedX=lv_maxspdX*sin(90*lv_help);										
										lv_speedY*=-1;	// turn Y
										object[lv_id].pos_y+=lv_speedY*time_step*2;
										break;
						}
					} 
				}
			}
		}
		
		wait(1);
	}
}
//----------------------------------------------------------------------------------------------------------------
// set the center of the panel
function set_center(PANEL* p_pan){
	p_pan.center_x=bmap_width(p_pan.bmap)*p_pan.scale_x/2;
	p_pan.center_y=bmap_height(p_pan.bmap)*p_pan.scale_y/2;
}
//----------------------------------------------------------------------------------------------------------------
// the catcher
function catcher(PANEL* p_catcher){	
	eCatcher=p_catcher;
	while(1){
		p_catcher.pos_x=clamp(p_catcher.pos_x+time_step*mouse_force.x*100, 0, screen_size.x-bmap_width(p_catcher.bmap)*p_catcher.scale_x);
		wait(1);
	}	
}
//================================================================================================================
// main function
void main(){
int i, j, k;
	
	// set screen
	//video_set(sys_metrics(0),sys_metrics(1), 32, 1);	
	video_set(1024, 768, 32, 1);	
	fps_max=70;	// limit frames	
	mouse_pointer=0;	// no mouse
	
	// create the bmaps
	bmp_ball=bmap_createblack(32, 32, 32);
	bmap_fill (bmp_ball, vector(20,20,250), 100);
	
	bmp_wall=bmap_createblack(32, 32, 32);
	bmap_fill (bmp_wall, vector(250,250,250), 100);	
	
	// show info & scoring
	txt_info.pos_y=screen_size.y-35;
	pan_score.pos_x=screen_size.x/2;
	
	// left wall (layer of walls are 0)
	object[0]=pan_create("bmap=bmp_wall;flags=VISIBLE;pos_x=0; pos_y=0;", 0);
	object[0].scale_y=screen_size.y/32;
	set_center(object[0]);
	objtype[0]=1;	// it's a wall
	
	// right wall (layer of walls are 0)
	object[1]=pan_create("bmap=bmp_wall;flags=VISIBLE;pos_x=0; pos_y=0;", 0);
	object[1].scale_y=screen_size.y/32;	
	object[1].pos_x=screen_size.x-bmap_width(object[1].bmap);
	set_center(object[1]);	
	objtype[1]=1;	// it's a wall
	
	// bottom wall (layer of walls are 0)	
	object[2]=pan_create("bmap=bmp_wall;flags=VISIBLE;pos_x=0; pos_y=0;", 0);
	object[2].scale_x=screen_size.x/32;	
	object[2].pos_y=screen_size.y-bmap_height(object[2].bmap);
	set_center(object[2]);
	objtype[2]=1;	// it's a wall
	
	// top wall	(layer of walls are 0)
	object[3]=pan_create("bmap=bmp_wall;flags=VISIBLE;pos_x=0; pos_y=0;", 0);
	object[3].scale_x=screen_size.x/32;
	set_center(object[3]);
	objtype[3]=1;	// it's a wall

	// create ball1 (a oval) (layer of balls are 0)
	object[4]=pan_create("bmap=bmp_ball;flags=VISIBLE;pos_x=0; pos_y=0;", 0);
	object[4].pos_x=screen_size.x*0.4;
	object[4].pos_y=screen_size.y*0.8;		
	set_center(object[4]);	
	objtype[4]=2;	// it's a ball	
	
	// create ball2 (layer of balls are 0)
	object[5]=pan_create("bmap=bmp_ball;flags=VISIBLE;pos_x=0; pos_y=0;", 0);
	object[5].pos_x=screen_size.x*0.55;
	object[5].pos_y=screen_size.y*0.8;	
	set_center(object[5]);
	objtype[5]=2;	// it's a ball

	gv_max_objects=5; 	// 5 ojbects now

	// some bricks (like walls but with an other objtype)
	for(j=5;j>0;j--){
		for(i=0;i<j;i++){
			gv_max_objects+=1;	// new object
			object[gv_max_objects]=pan_create("bmap=bmp_wall;flags=VISIBLE;", 0);
			object[gv_max_objects].scale_x=2;			
			object[gv_max_objects].pos_x=screen_size.x*0.2+i*66;
			object[gv_max_objects].pos_y=screen_size.y*0.2+j*33;
			set_center(object[gv_max_objects]);
			objtype[gv_max_objects]=3;	// it's a brick
			
			// mirrored (and right side)
			gv_max_objects+=1;	// new object
			object[gv_max_objects]=pan_create("bmap=bmp_wall;flags=VISIBLE;", 0);
			object[gv_max_objects].scale_x=2;			
			object[gv_max_objects].pos_x=screen_size.x*0.8-i*66;
			object[gv_max_objects].pos_y=screen_size.y*0.2+j*33;
			set_center(object[gv_max_objects]);
			objtype[gv_max_objects]=3;	// it's a brick			
			
		}
	}
	
	// the catcher
	gv_max_objects+=1;
	object[gv_max_objects]=pan_create("bmap=bmp_wall;flags=VISIBLE;pos_x=500; pos_y=700;", 0);
	object[gv_max_objects].pos_y=screen_size.y*0.9;
	set_center(object[gv_max_objects]);
	object[gv_max_objects].scale_x=3;	
	objtype[gv_max_objects]=4;	// it's like a wall
	
	// the catcher controll
	catcher(object[gv_max_objects]);
	
	// wait a moment...
	wait(-1);
	
	// start moving the ball/s	
	move_ball(4, -screen_size.y*0.024, -screen_size.y*0.021);
	move_ball(5, screen_size.y*0.026, -screen_size.y*0.022);
	
	// slowly fade out info
	wait(-4);
	while(txt_info.alpha>0){
		txt_info.alpha-=time_step;
		wait(1);
	}
	reset(txt_info, VISIBLE);
}
